<template>
  <v-container fluid>
    <div class="dashboard-page">
      <v-row no-gutters class="d-flex justify-space-between mt-10 mb-6">
        <h1 class="page-title">Расчёт</h1>
      </v-row>
      <v-row>
        <v-row>
          <v-col
            v-for="substance in substanceStore.substances"
            :key="substance.code"
            lg="3"
            sm="6"
            md="5"
            cols="12"
          >
            <v-row class="pa-3">
              <div v-katex:auto>\({{ substance.latexCode }}\)</div>
              <v-text-field
                type="number"
                v-model="substance.value"
                required
              ></v-text-field>
            </v-row>
          </v-col>
          <v-col class="d-flex justify-space-between" cols="12">
            <v-btn large block @click="compute" color="primary">
              Compute
            </v-btn>
          </v-col>
        </v-row>
        <v-col
          lg="6"
          sm="12"
          md="6"
          cols="12"
          v-for="type in chartTypes"
          :key="type"
        >
          <main-chart
            v-if="substanceStore.series.length"
            :series="substanceStore.series"
            :type="type"
          ></main-chart>
        </v-col>
        <v-col cols="12">
          <table-d :series="substanceStore.series" />
        </v-col>
        <v-col class="d-flex justify-space-between" cols="12">
          <v-btn
            large
            block
            @click="makeReport"
            color="primary"
            v-if="substanceStore.series.length"
          >
            Скачать отчёт
          </v-btn>
        </v-col>
      </v-row>
    </div>
  </v-container>
</template>

<script lang="ts">
import Vue from "vue";
import { Component, Prop } from "vue-property-decorator";
import SubstanceModule from "@/store/modules/substances";
import ApplicationModule from "@/store/modules/application";
import { getModule } from "vuex-module-decorators";
import MainChart from "@/components/MainChart/MainChart.vue";
import TableD from "@/components/Table/TableD.vue";

@Component({ components: { MainChart, TableD } })
export default class Dashboard extends Vue {
  private substanceStore = getModule(SubstanceModule, this.$store);
  private applicationStore = getModule(ApplicationModule, this.$store);

  private chartTypes = ["surface"];

  makeReport() {
    this.substanceStore.report(this.substanceStore.substances);
  }

  created() {
    this.substanceStore.fetchSubstances();
  }

  compute() {
    this.applicationStore.start()
    this.substanceStore.calculateSeries(this.substanceStore.substances);
  }
}
</script>

<style src="./Dashboard.scss" lang="scss"/>
